#!/usr/bin/perl

$|++;

## This is an example Perl script which demonstrates how to 
## use InterShipper.pm which should have been included with this file.

use strict;

use InterShipper;
use CGI;

my $cgi = CGI->new;

print $cgi->header;
## set global vars
my $API_URL = 'http://www.intershipper.com/Interface/Intershipper/XML/v2.0/HTTP.jsp';
my $VERSION = '2.0.0.0';
my $USERNAME = 'username';
my $PASSWORD = 'password';
## end globals

#set session query vars
my %data =  (
   ShipmentID => "1234",
   QueryID => "23456",
   Carriers =>
   [
    {CarrierCode => "UPS",
     CarrierAccount => "123456789",
     CarrierInvoiced => "1"},
   ],
   Classes =>
   [
    {ClassCode => "1DY"},
   ],
   DeliveryType => "COM",
   ShipMethod => "DRP",
   OriginationName => "John Smith",
   OriginationAddress1 => "465 Tyende Ovi",
   OriginationAddress2 => "",
   OriginationAddress3 => "",
   OriginationCity => "Flagstaff",
   OriginationState => "AZ",
   OriginationPostal => "86001",
   OriginationCountry => "US",
   DestinationName => "Jane Doe",
   DestinationAddress1 => "466 Tyende Ovi",
   DestinationAddress2 => "",
   DestinationAddress3 => "",
   DestinationCity => "Flagstaff",
   DestinationState => "AZ",
   DestinationPostal => "86001",
   DestinationCountry => "US",
   Currency => "USD",
   Packages =>
   [
    {BoxID => "1",
     Weight => "10",
     WeightUnit => "LB",
     Length => "10",
     Width => "10",
     Height => "10",
     DimensionalUnit => "IN",
     Packaging => "BOX",
     Contents => "OTR",
     Cod => "18500",
     Insurance => "15000"},
    ],
   Options =>
   [
    {OptionCode => "SDD"},
   ],
  );

#do the real work

#set the global vars
InterShipper::set_credentials($USERNAME,$PASSWORD,$VERSION,$API_URL);

#send query data to InterShipper server
my $result = InterShipper::compute_charges(%data);
#print error if bad result
print "error: $result\n" unless (ref $result); 

#prints simplified data returned from server
#InterShipper::print_data($result);

#get two hashes to be used in shipping menu (form)
my $menu_data = InterShipper::get_menu_data($result);
my ($amount,$carrier_code) = @$menu_data;

print "<form><select>";
for (keys %$amount) {
	$amount->{$_} = $amount->{$_}/100;
	print "<option>$carrier_code->{$_} - \$$amount->{$_}\n";
}
print "</select></form>";

exit;